package test;

import java.util.Random;
import java.util.concurrent.CountDownLatch;

import javax.jms.BytesMessage;
import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.Queue;
import javax.jms.Session;

/**
 * @Knet Technology Department
 * @author  
 * 2011-7-14
 */
public class BasicTest {
	
	static Random rd = new Random();
	
	static int sendMessagesPerThread = 4000;
	
	static class Sender extends Thread{
		
		private CountDownLatch cdl;
		
		private Session session;
		
		private Queue queue;
		
		public Sender(CountDownLatch cdl, Session session, Queue queue) {
			super();
			this.cdl = cdl;
			this.session = session;
			this.queue = queue;
		}

		@Override
		public void run() {
			MessageProducer producer = null;
			try {
				producer = session.createProducer(queue);
				long sst = System.currentTimeMillis();
				for(int i=0; i<sendMessagesPerThread; i++){
					BytesMessage bm = session.createBytesMessage();
					bm.writeBytes(createRandomBytes(1000));
					producer.send(bm);
				}
				double se = (System.currentTimeMillis() - sst) / 1000.0;
				this.cdl.countDown();
				double av = sendMessagesPerThread / se;
				System.out.println(Thread.currentThread().getName() + " spends " + se + ", " + av);
			} catch (JMSException e) {
				e.printStackTrace();
			} finally{
				if(producer != null){
					try {
						producer.close();
					} catch (JMSException e) {
						e.printStackTrace();
					}
				}
				try {
					session.close();
				} catch (JMSException e) {
					e.printStackTrace();
				}
			}
			
		}
		
	}
	
	static byte[] createRandomBytes(int length){
		byte[] bs = new byte[length];
		rd.nextBytes(bs);
		return bs;
	}
}
